package laskuri3;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: EventBeanLaskuri</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: University of Jyvskyl</p>
 * @author Miika Nurminen
 * @version 1.0
 *
 * @todo lis nollaa-nappi ja summalabel, joka kytt laskurin onchange-tapahtumaa
 */

public class LaskuriFrame extends JFrame implements BeanLaskuriListener {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JPanel jPanel1 = new JPanel();
  LisaaButton buttonHA = new LisaaButton();
  GridLayout gridLayout1 = new GridLayout();
  LisaaButton buttonKA = new LisaaButton();
  BeanLaskuri laskuriKA = new BeanLaskuri();
  BeanLaskuri laskuriHA = new BeanLaskuri();
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabel1 = new JLabel();

  //Construct the frame
  public LaskuriFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(301, 214));
    this.setTitle("Autolaskuri");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new LaskuriFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new LaskuriFrame_jMenuHelpAbout_ActionAdapter(this));
    buttonHA.setMinimumSize(new Dimension(93, 25));
    buttonHA.setPreferredSize(new Dimension(93, 25));
    buttonHA.setMnemonic('0');
    buttonHA.setText("Henkilautot");
    buttonHA.setLaskuri(laskuriHA);
    jPanel1.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setRows(2);
    gridLayout1.setVgap(0);
    buttonKA.setActionCommand("Kuorma-autot");
    buttonKA.setText("Kuorma-autot");
    buttonKA.setLaskuri(laskuriKA);
    laskuriKA.setBorder(BorderFactory.createRaisedBevelBorder());
    laskuriKA.addBeanLaskuriListener(this);
    laskuriHA.setBorder(BorderFactory.createRaisedBevelBorder());
    laskuriHA.setToolTipText("");
    laskuriHA.setVerifyInputWhenFocusTarget(true);
    laskuriHA.addBeanLaskuriListener(this);
    jLabel1.setMaximumSize(new Dimension(34, 40));
    jLabel1.setMinimumSize(new Dimension(34, 15));
    jLabel1.setOpaque(false);
    jLabel1.setPreferredSize(new Dimension(34, 40));
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setText("");
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    contentPane.add(jPanel1,  BorderLayout.CENTER);
    jPanel1.add(laskuriHA, null);
    jPanel1.add(laskuriKA, null);
    jPanel1.add(buttonHA, null);
    jPanel1.add(buttonKA, null);
    contentPane.add(jLabel1, BorderLayout.SOUTH);
    this.setJMenuBar(jMenuBar1);
    onChange(null); // pivitt labelin
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    LaskuriFrame_AboutBox dlg = new LaskuriFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }


  public void onChange(BeanLaskuriEvent e) {
    jLabel1.setText("Yhteens "+Integer.toString(laskuriHA.getCount()+laskuriKA.getCount())+" ajoneuvoa.");
  }
}

class LaskuriFrame_jMenuFileExit_ActionAdapter implements ActionListener {
  LaskuriFrame adaptee;

  LaskuriFrame_jMenuFileExit_ActionAdapter(LaskuriFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class LaskuriFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
  LaskuriFrame adaptee;

  LaskuriFrame_jMenuHelpAbout_ActionAdapter(LaskuriFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

